#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n, m;
    cin>>n>>m;
    int max_zbir;
    int zbir = 0;
    int limitL[m], limitD[m];
    for(int i = 0; i < n; i++) {
        int x;
        cin>>x>>max_zbir;
    }
    for(int i = 0 ; i < m; i++) {
        cin>>limitL[i]>>limitD[i];
        zbir += limitL[i];
    }
    max_zbir -= zbir;
    int red[m];
    int poslednji = 0;
    for(int i = 0; i < m && max_zbir > 0; i++, poslednji++) {
        int potencijal = limitD[i] - limitL[i];
        if(potencijal >= max_zbir) {
            red[i] = limitL[i] + max_zbir;
            max_zbir = 0;
        }
        else {
            red[i] = limitL[i] + potencijal;
            max_zbir -= potencijal;
        }
        cout<<red[i]<<" ";
    }
    for(int i = poslednji; i < m; i++) {
        cout<<limitL[i]<<" ";
    }
    return 0;
}